#ifndef _KEYBOARD_H_
#define _KEYBOARD_H_


enum BD_KEYS
{
   KEY_GAME_UP = 1,
   KEY_GAME_DOWN,
   KEY_GAME_LEFT,
   KEY_GAME_RIGHT,
   KEY_GAME_FIRE,
   KEY_GAME_QUIT,
   KEY_GAME_RESET,
   KEY_GAME_PLAYERS,
   KEY_GAME_SCORE,
   KEY_GAME_EDITOR,

   KEY_HELP,
   KEY_SPACE,
   KEY_ENTER,
   KEY_SNAPSHOT,

   KEY_EDITOR_UP,
   KEY_EDITOR_DOWN,
   KEY_EDITOR_LEFT,
   KEY_EDITOR_RIGHT,
   KEY_EDITOR_CLEAR,
   KEY_EDITOR_UNDO,
   KEY_EDITOR_LOAD,
   KEY_EDITOR_SAVE,
   KEY_EDITOR_QUIT,
   KEY_EDITOR_INSERT,
   KEY_EDITOR_HOME,
   KEY_EDITOR_END,
   KEY_EDITOR_TOP,
   KEY_EDITOR_BOTTOM,
   KEY_EDITOR_COLORS,

   KEY_EDITOR_1,
   KEY_EDITOR_2,
   KEY_EDITOR_3,
   KEY_EDITOR_4,
   KEY_EDITOR_5,
   KEY_EDITOR_6,
   KEY_EDITOR_7,
   KEY_EDITOR_8,
   KEY_EDITOR_9,
   KEY_EDITOR_0,
   KEY_EDITOR_R,
   KEY_EDITOR_E,

   BD_MAXKEYS
};


struct KEYS_DATA
{
   short shift_code;
   short key_code;
};


#if defined(__STDC__) || defined(__cplusplus) || defined(NeedFunctionPrototypes)
#  define __PARMS(s) s
#else
#  define __PARMS(s) ()
#endif

#ifdef USE_X11
void  key_callback      __PARMS((XKeyEvent *event));
#endif

short key_pressed_code  __PARMS((short key_code, short repeat_flag));
short key_pressed_ascii __PARMS((char key_ascii, short repeat_flag));
short key_pressed_time  __PARMS((short key_code, short repeat_flag, time_t *current_time));
short key_update        __PARMS((void));

#undef __PARMS
#endif /* _KEYBOARD_H_ */
